/****************************************************************************
**  CUBE        http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 2023                                                     **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


#include "config.h"

#include "FileServerPlugin.h"
#include <iostream>
#include <fstream>
#include <string>

using namespace std;
using namespace fileserver_plugin;

const char*
FileServerPlugin::name() const
{
    return "FileServerPlugin";
}

std::vector<unsigned char>
FileServerPlugin::send( const std::vector<unsigned char>& filedata, cube::CubeProxy* )
{
    std::vector<unsigned char> source;
    string                     line;

    std::string filename { filedata.begin(), filedata.end() };

    cerr << "FileServerPlugin::request for file " << filename << endl;
    ifstream file( filename );
    if ( file.is_open() )
    {
        std::vector<unsigned char> bytes(
            ( std::istreambuf_iterator<char>( file ) ),
            ( std::istreambuf_iterator<char>() ) );
        file.close();

        return bytes;
    }

    return source;
}
